(function () {
  'use strict';

  angular.module('inventoryMonitoringApp').controller('MainCtrl', ['$scope', '$location', 'ChartJsPlugins', MainCtrl]);

  function MainCtrl($scope, $location, chartJsPlugins) {
    var main = this;
    var accessibleReports = [];
    var reports = [{
      name: 'contracts'
    }];


    // When user access the report from home
    if($location.path() === '') {
      initiateReport();
    }
    // When user access the report by refreshing the current page(for Dev use)
    else {
      var currentReportName = $location.path().replace('/', '');
      initiateReport(currentReportName);
    }

    main.mainNavigation = true;

    main.getAccessibleReports = function() {
      return accessibleReports;
    };

    main.applyActiveStyle = function(index) {
      if(main.activeReport.name === accessibleReports[index].name) {
        return 'active';
      }
    };

    main.switchReport = function(index) {
      main.activeReport = accessibleReports[index];
      $location.path('/' + main.activeReport.name);
    };

    main.goToMainNavigation = function() {
      main.mainNavigation = true;
      $scope.$broadcast('goToMainNavigation');
    };

    $scope.$on('goToDetailNavigation', function(event, data) {
      main.detailViewTitle = data;
      main.mainNavigation = false;
    });

    $scope.$on('reportLanded', function() {
      main.reportLanded = true;
    });

    Chart.pluginService.register(chartJsPlugins.centerLabel);

    function initiateReport(name) {
      if(reports.length) {
        accessibleReports = reports;

        if(name) {
          var foundActiveReport = _.find(accessibleReports, function(report) {
            return report.name === name;
          });
          if(foundActiveReport) {
            main.activeReport = foundActiveReport;
          } else {
            main.activeReport = accessibleReports[0];
          }
        } else {
          main.activeReport = accessibleReports[0];
        }

        $location.path('/' + main.activeReport.name);
      }
    }
  }
})();
