(function() {
  'use strict';

  angular.module('inventoryMonitoringApp').factory('BrandService', ['$q', 'Endpoints', 'Utility', factoryFn]);

  function factoryFn($q, endpoints, utility) {
    var service = this;
    var brands = {};
    var PRODUCT_FIELD_TEXT = 'Product_vod__c';

    service.fetchBrands = function(brandIds) {
      var deferred = $q.defer();

      if(brands.data) {
        deferred.resolve(_.cloneDeep(brands));
      } else {
        endpoints.fetchAllBrands(brandIds).then(function(response) {
          var brandsData;

          brands.data = response;
          brandsData = utility.normalizeArray(brands.data, PRODUCT_FIELD_TEXT);

          deferred.resolve(brandsData);
        }, utility.genericQueryErrorHandler(deferred));
      }

      return deferred.promise;
    };

    service.getAllBrands = function() {
      var brandsData = utility.normalizeArray(brands.data, PRODUCT_FIELD_TEXT);

      return _.cloneDeep(brandsData);
    };

    return service;
  }
})();
