(function() {
  'use strict';

  angular.module('inventoryMonitoringApp').factory('ContractService', ['$q', 'Endpoints', 'Utility', factoryFn]);

  function factoryFn($q, endpoints, utility) {
    var service = this;
    var contract = {};

    service.fetchContract = function(id) {
      var deferred = $q.defer();

      if(contract.data) {
        deferred.resolve(_.cloneDeep(contract.data));
      } else {
        endpoints.fetchContract(id).then(function(response) {
          var contractData;

          contract.data = response;
          contractData = utility.normalizeArray(contract.data, 'Contract_vod__c');

          deferred.resolve(contractData);
        }, utility.genericQueryErrorHandler(deferred));
      }

      return deferred.promise;
    };

    function contractDataGetter(field) {
      var contractResponse = contract.data.Contract_vod__c;

      if (Array.isArray(contractResponse) && contractResponse[0]) {
        return contractResponse[0][field] || '';
      }

      return '';
    }

    service.getName = function() {
      return contractDataGetter('Name');
    };

    service.getStartDate = function() {
      return contractDataGetter('Start_Date_vod__c');
    };

    service.getEndDate = function() {
      return contractDataGetter('End_Date_vod__c');
    };

    return service;
  }
})();
