(function() {
  'use strict';

  angular.module('inventoryMonitoringApp').factory('InvMonitoringService', ['$q', 'Endpoints', 'Utility', factoryFn]);

  function factoryFn($q, endpoints, utility) {
    var service = this;
    var inventoryMonitoring = {};

    service.fetchInventoryMonitoring = function() {
      var deferred = $q.defer();

      if(inventoryMonitoring.data) {
        deferred.resolve(_.cloneDeep(inventoryMonitoring.data));
      } else {
        endpoints.fetchInventoryMonitoring(inventoryMonitoring.currentId).then(function(response) {
          var invMonitoring;

          inventoryMonitoring.data = response;
          invMonitoring = utility.normalizeArray(inventoryMonitoring.data, 'Inventory_Monitoring_vod__c');

          deferred.resolve(invMonitoring);
        }, utility.genericQueryErrorHandler(deferred));
      }

      return deferred.promise;
    };

    service.setCurrentIMId = function(currentId) {
      inventoryMonitoring.currentId = currentId;
    };

    service.getCurrentIMId = function() {
      return inventoryMonitoring.currentId;
    };

    service.getInventoryMonitoringField = function (fieldName) {
      var inventoryResponse = inventoryMonitoring.data.Inventory_Monitoring_vod__c;

      if (Array.isArray(inventoryResponse) && inventoryResponse[0]) {
        return inventoryResponse[0][fieldName] || '';
      }

      return '';
    };

    return service;
  }
})();
