(function() {
  'use strict';

  angular.module('inventoryMonitoringApp')
         .factory('MessageService', ['$q', 'Endpoints', 'Utility', factoryFn]);

  function factoryFn($q, endpoints, utility) {
    var messageService = this;
    var translatedMessages = null;

    messageService.fetchTranslations = function(messagesToGet, userLocale) {
      var deferred = $q.defer();

      endpoints.getTranslations(messagesToGet, userLocale).then(function(resp) {
        deferred.resolve(resp);
      }, utility.genericQueryErrorHandler(deferred));

      return deferred.promise;
    };

    messageService.getTranslatedMessages = function() {
      return translatedMessages;
    };

    messageService.setTranslatedMessages = function(translatedMsg) {
      translatedMessages = translatedMsg;
    };

    messageService.getMessage = function(key) {
      if(translatedMessages && translatedMessages[key]) {
        return translatedMessages[key];
      } else {
        return key;
      }
    };

    return messageService;
  }
})();
