(function () {
    'use strict';

  angular.module('inventoryMonitoringApp').factory('ObjectFieldSecurity', ['$q', function($q) {
    var objectFieldSecurity = this;
    var ds = window.ds;
    var notAccessible = {};

    function genericQueryErrorHandler(deferred) {
      return function(error) {
        deferred.reject(error);
      };
    }

    function getNotAccessibleFields() {
      return notAccessible;
    }

    function findAvailableFields(configObject) {
      var deferred = $q.defer();
      var result = [];

      ds.getObjectMetadata(configObject).then(function (response) {
        var availableFields = response.data.fields.map(function(field) {
          return field.name;
        });

        notAccessible[configObject.object] = {
          fields: []
        };

        configObject.fields.forEach(function(fieldName){
          if (availableFields.indexOf(fieldName) !== -1) {
            result.push(fieldName);
          }else {
            notAccessible[configObject.object].fields.push(fieldName);
          }
        });

        deferred.resolve(result);
      }, genericQueryErrorHandler(deferred));

      return deferred.promise;
    }

    objectFieldSecurity.findAvailableFields = findAvailableFields;
    objectFieldSecurity.getNotAccessibleFields = getNotAccessibleFields;

    return objectFieldSecurity;

  }]);

}());
