(function() {
  'use strict';

  angular.module('inventoryMonitoringApp').factory('OrderLineService', ['$q', 'Endpoints', 'Utility', factoryFn]);

  function factoryFn($q, endpoints, utility) {
    var service = this;
    var orderLines = {};

    service.fetchOrderLines = function(productIds, orderIds) {
      var deferred = $q.defer();

      endpoints.fetchOrderLines(productIds, orderIds).then(function(response) {
        var orderLineData;

        orderLines.data = response;
        orderLineData = utility.normalizeArray(orderLines.data, 'Order_Line_vod__c');

        deferred.resolve(orderLineData);
      }, utility.genericQueryErrorHandler(deferred));

      return deferred.promise;
    };

    service.mergeOrderDateFromOrder = function(orders) {
      var orderLineData = utility.normalizeArray(orderLines.data, 'Order_Line_vod__c');

      return orderLineData.map(function(orderLine) {
        orders.forEach(function(order){
          if (orderLine.Order_vod__c === order.Id) {
            orderLine.Order_Date_vod__c = order.Order_Date_vod__c;
          }
        });

        return orderLine;
      });

    };

    return service;
  }
})();
