(function() {
  'use strict';

  angular.module('inventoryMonitoringApp')
         .factory('UserService', ['$q', 'Endpoints', 'Utility', factoryFn]);

  function factoryFn($q, endpoints, utility) {
    var userService = this;
    var currentUser = null;

    userService.fetchCurrentUser = function() {
      var deferred = $q.defer();

      if(!currentUser) {
        endpoints.fetchCurrentUser().then(function(resp) {
          currentUser = {};

          if(resp.User && resp.User[0]) {
            var rawUserData = resp.User[0];
            for(var key in rawUserData) {
              if (rawUserData.hasOwnProperty(key)) {
                currentUser[key] = rawUserData[key];
              }
            }
          }
          deferred.resolve(currentUser);
        }, utility.genericQueryErrorHandler(deferred));

      } else {
        deferred.resolve(currentUser);
      }

      return deferred.promise;
    };

    userService.getCurrentUser = function() {
      return currentUser;
    };

    return userService;
  }
})();
