(function () {
  'use strict';

  angular.module('inventoryMonitoringApp').value('queries', {
    inventoryMonitoring: {
      object: 'Inventory_Monitoring_vod__c',
      fields: [
        'Id',
        'Contract_vod__c',
        'Inventory_Monitoring_Date_vod__c'
      ],
      where: 'Id = _id'
    },
    inventoryMonitoringLine: {
      object: 'Inventory_Monitoring_Line_vod__c',
      fields: [
        'Product_vod__c',
        'Facings_simple_vod__c',
        'Position_vod__c',
        'Layer_vod__c',
        'Consumer_Price_vod__c',
        'Inventory_vod__c',
        'Id',
        'Inventory_Monitoring_vod__c'
      ],
      where: 'Inventory_Monitoring_vod__c = _invMonitoringId',
      picklists: ['Layer_vod__c', 'Position_vod__c']
    },
    allBrands: {
      object: 'Product_vod__c',
      fields: ['Id', 'Name', 'Parent_Product_vod__c'],
      where: "Product_Type_vod__c = 'Detail' AND Id IN "
    },
    products: {
      object: 'Product_vod__c',
      fields: ['Id', 'Name', 'Parent_Product_vod__c', 'Inventory_Monitoring_vod__c', 'Product_Type_vod__c', 'Product_Identifier_vod__c'],
      where: 'Id IN '
    },
    contract:{
      object: 'Contract_vod__c',
      fields: [
        'Id',
        'Name',
        'Start_Date_vod__c',
        'End_Date_vod__c'
      ],
      where: 'Id = _id'
    },
    contractLine:{
      object: 'Contract_Line_vod__c',
      fields: [
        'Id',
        'Contract_vod__c',
        'IM_Facings_simple_vod__c',
        'IM_Position_vod__c',
        'IM_Layer_vod__c',
        'IM_Consumer_Price_vod__c',
        'IM_Inventory_vod__c',
        'Product_vod__c',
        'Start_Date_vod__c',
        'End_Date_vod__c'
      ],
      where: 'Contract_vod__c = _contractId',
      picklists: ['IM_Layer_vod__c', 'IM_Position_vod__c']
    },
    order:{
      object: 'Order_vod__c',
      fields: [
        'Id',
        'Order_Date_vod__c',
        'Parent_Order_vod__c'
      ],
      where: "Account_vod__c = _accountId AND Status_vod__c = 'Submitted_vod' AND (Parent_Order_vod__c = _empty OR Parent_Order_vod__c = NULL) AND Order_Date_vod__c _operand _today"
    },
    orderLine:{
      object: 'Order_Line_vod__c',
      fields: [
        'Id',
        'LastModifiedDate',
        'Order_vod__c',
        'Quantity_vod__c',
        'Product_vod__c'
      ],
      where: 'Product_vod__c IN _productIds AND Order_vod__c IN '
    },
    user: {
      object: 'User',
      fields: ['Id', 'LanguageLocaleKey', 'LocaleSidKey'],
      where: 'Id = _userId'
    }
  });

}());
